// --> See Define.Txt for a line-by-line explanation of this file.
// It may help to browse through BASIC.Txt first.

uCalc Prefix "uCalc Define Pattern: "   
   :::        ~~ Properties: ucStatementSep
   ~t         ~~ Properties: ucCurrentThread
   ~Eval      ~~ Properties: ucEvalInsert
   ~Expand    ~~ Properties: ucExpandInsert
   \\q ~~ \\q ~~ Properties: ucQuotedText + ucLiteral ~~ DataType: String
   ~mStart    ~~ Properties: ucPartialBlockStart
   ~mEnd      ~~ Properties: ucPartialBlockEnd
   \{ ~~ \}   ~~ Properties: ucCodeBlock ~~ DataType: Stack _
      ~~ Address: ucAddr(uc_Func_Populate_Stack) ~~ Rank: 10
uCalc Prefix ""

// All of the following syntax defs use a default precedence level of 1
// +++ VarName extentions [@#!%&$]? are for BASIC. May remove for other langs.

uCalc Prefix "uCalc Syntax "
   Name_: ::= Name:

   Var: {VarName:"[ ]*[a-z_][0-9a-z_]*[@#!%&$]?"} [As {Type}] _
      [{ = {Value} | At {Addr:" .+"} }] ::=          _
      variable ~~ Name_: {VarName}                   _
      {Type: ~~ DataType: {Type}}                    _
      {Value: ~~ Value: {Value}}                     _
      {Addr: ~~ Address: {Addr}}

   Var: {VarName:"[ ]*[a-z_][0-9a-z_]*"} As AnyType ::= AnyType~~Var: {VarName}
   Var: {PassBy:"( +ByRef)|( +ByVal)|( +ByHandle)|( +ByExpr)"}::={PassBy}~~Var:
   Var: {Def} ... ::= Var: {Def} ~~ VariableArgList
   Var: ... ::= Var: _ ~~ VariableArgList

   Var: {"[ ]*"}{ArrayName:"[a-z_][0-9a-z_]*[@#!%&$]?"} ({MaxIndex}) [{etc}] _
      ::= SetInput(\quCalc Syntax {ArrayName} ({Index})                      _
          ::= ValueAtAddr(~Eval(DataType("{ArrayName}")),                    _
                          ~Eval(Address("{ArrayName}")), {Index})\q)         _
      Count: {MaxIndex} ~~ Var: {ArrayName} {etc}


   Params: ([{SingleParam}])::=IsParam ~~ { {SingleParam: Var: {SingleParam}} }
   Params: ({Variable:"[^=]+"} = {Default}) _
           ::= Params: ({Variable} ~~ TextData: {Default})
   Params: ({Param1}, {OtherParams}) ::= Params: ({Param1}) _
           ~~ Params: ({OtherParams})
   Param:  {ParamDef} ~~ ::= IsParam ~~ { Var: {ParamDef} } ~~


   Func: {FuncName} ([{ParamList}])                                           _
      [As {type:" +[a-z]+[a-z0-9]*"}] [{ At {addr:".+"} | = {Def:".+"} }] ::= _
      Properties: ucFunction + ucPrefix ~~                                    _
      Params: ({ParamList}) ~~ DataType: {type} ~~ Name_: {FuncName}          _
      {addr: ~~ Address: {addr} ~~ StdCall} ~~ FuncBody: {Def}

   Func:: {Def:".+"} ::= NativeCall ~~ Func: {Def}


   Op: {Name} "{" {Operand} "}" [As {type:" +[a-z]+[a-z0-9]*"}] _
      [{ At {addr} | = {Def:".+"} }] ::= _
      Properties: ucPrefix+ucOperator ~~ Param: {Operand} ~~ Name_: {Name} ~~ _
      DataType: {type} {addr: ~~ Address: {addr} ~~ StdCall} ~~ FuncBody: {Def}

   Op: "{" {Operand} "}" {Name} [As {type:" +[a-z]+[a-z0-9]*"}] _
      [{ At {addr} | = {Def:".+"} }]  ::= _
      Properties: ucPostfix+ucOperator ~~ Param: {Operand} ~~ Name_: {Name} ~~ _
      DataType: {type} {addr: ~~ Address: {addr} ~~ StdCall} ~~ FuncBody: {Def}

   Op: "{"{LeftOp}"}" {Name} "{" {RightOp} "}" [As {type:" +[a-z]+[a-z0-9]*"}] _
      [{ At {addr} | = {Def:".+"} }] ::= Name_: {Name} ~~                      _
      Properties: ucInfix+ucOperator ~~ Param: {LeftOp} ~~ Param: {RightOp} ~~ _
      DataType: {type} {addr: ~~ Address: {addr} ~~ StdCall} ~~ FuncBody: {Def}

   Op: {pValue:' *[0-9]+ '} {Def} ::= Precedence: {pValue} ~~ Op: {Def}

   Op:: {Def:".+"} ::= NativeCall ~~ Op: {Def}


   syntax {Def:" .+"} ::= SetInput("ucalc syntax {Def}")
   func   {Def:" .+"} ::= SetInput("ucalc define func: {Def}")
   var    {Def:" .+"} ::= SetInput("ucalc define var: {Def}")
   expand {Def:" .+"} ::= SetInput("ucalc expand {Def}")
uCalc Prefix ""

uCalc Define PassOnce ~~ Syntax: Quote({text}) ::= "{text}"
